%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function RBAR_list = Get_RBARs_From_Nodes(Node_list, Excluded_MPCs)

% Существование узлов из списка Node_list должно проверяться вне данной функции до ее вызова
% Существование MPC из списка Excluded_MPCs должно проверяться вне данной функции до ее вызова

global DB_MPC;
global AT_MPC;

if (isempty(Node_list))
    RBAR_list = [];
    return;
end

if (isempty(DB_MPC))
    RBAR_list = [];
    return;
end

Node_list = unique(Node_list);

MPC_list = Get_MPCs_From_Nodes(Node_list, Excluded_MPCs);

if (isempty(MPC_list))
    RBAR_list = [];
    return;
end

N_RBAR = 0;

for i=1:size(MPC_list,1)
    if (strcmp(DB_MPC{AT_MPC(MPC_list(i))}.type, 'RBAR'))
        N_RBAR = N_RBAR + 1;
    end
end

if (N_RBAR == 0)
    RBAR_list = [];
    return;
end

RBAR_list = zeros(N_RBAR,1);

N_RBAR = 0;

for i=1:size(MPC_list,1)
    
    if (strcmp(DB_MPC{AT_MPC(MPC_list(i))}.type, 'RBAR'))
        N_RBAR = N_RBAR + 1;
        RBAR_list(N_RBAR) = MPC_list(i);
    end
    
end
